
!ZipArchive methodsFor: '*deligemstone-zipping' stamp: 'TimFelgentreff 01/14/2011 00:58'!
addTree: aFileNameOrDirectory match: aBlock
	| nameSize |	
	nameSize := aFileNameOrDirectory isString
		ifTrue: [aFileNameOrDirectory size]
		ifFalse: [aFileNameOrDirectory pathName size].	
	^ self	
		addTree: aFileNameOrDirectory
		removingFirstCharacters: nameSize + 1
		match: aBlock! !

!ZipArchive methodsFor: '*deligemstone-zipping' stamp: 'TimFelgentreff 01/15/2011 08:16'!
addTree: aFileNameOrDirectory removingFirstCharacters: n match: aBlock
	| dir fullPath relativePath |
	dir := (aFileNameOrDirectory isString)
		ifTrue: [ FileDirectory on: aFileNameOrDirectory ]
		ifFalse: [ aFileNameOrDirectory ].
	fullPath := dir pathName, dir slash.
	relativePath := fullPath copyFrom: n + 1 to: fullPath size.
	(dir entries select: [ :entry | aBlock value: entry])	
		do: [ :ea || fullName |
			fullName := fullPath, ea name.
			ea isDirectory "Directories aren't written in Zip"
				ifFalse: [ | newMember fd str |
					fd := ((FileDirectory forFileName: fullName) readOnlyFileNamed: fullName).
					str := (RWBinaryOrTextStream on: CharacterCollection new) binary; yourself.
					str nextPutAll: fd contents.
					newMember := ZipFileMember newFrom: str named: relativePath, ea name.
					self addMember: newMember ].
			ea isDirectory 
				ifTrue: [ self addTree: fullName removingFirstCharacters: n match: aBlock]].! !

!ZipArchive methodsFor: '*deligemstone-zipping' stamp: 'TimFelgentreff 01/15/2011 07:46'!
writeToFileNamed: aFilePath
	
	| fd str |
	fd := FileDirectory default forceNewFileNamed: aFilePath.
	str := RWBinaryOrTextStream on: CharacterCollection new.
	str binary.
	self writeTo: str.
	fd nextPutAll: str contents.
	str close.
	fd flush; close.! !

!DLAdminDeadlineZipComp methodsFor: '*deligemstone-zipping' stamp: 'TimFelgentreff 01/15/2011 07:33'!
createZipFile	
	
	ZipArchive new
		addTree: self baseDirectory, self zipDirectoryPath 
		match: [:e | true];
		writeToFileNamed: self zipFile.! !

!DLMail methodsFor: '*deligemstone-mailing' stamp: 'TimFelgentreff 01/12/2011 12:14'!
sendMail
 "Currently, Mailing does not work with username/password on GemStone"
	
 "| username password client |

	username := 'squeaky'.
	password := 'jflymcv98yM'.

	self receivers ifNotNilDo: [:recvs | recvs do: [:anEmailAdress |  
		SendMail new
			mailhostName: 'darwin.yetisoft.net';
			smtpPort: 4400;
			user: username;
			password: password;
			from: self sender;
			to: anEmailAdress;
			text: ('Subject: ', self subject, String cr,
				'From: ', self sender, String cr,
				'To: ', self receiversString, String cr,
				'Content-Type: text/html;charset=UTF-8', String cr,
				self text);
			send. ]]."! !

!DLModel methodsFor: '*deligemstone-saving' stamp: 'TimFelgentreff 01/12/2011 02:53'!
smalltalkDependentSaveStrategy
	"GemStone has commits around each request"! !
